#include <iostream>
using namespace std;

struct Date {
  int y, m, d;

  // 默认构造函数
  Date(){
    cout << "default constructor invoke!" << endl;
  }

  // 带参构造函数
  Date(int month, int day) {
    m = month;
    d = day;
    cout << "constructor invoke!" << endl;
  }

  // 带参构造函数
  Date(int year, int month, int day=1) {
    y = year;
    m = month;
    d = day;
    cout << "constructor invoke!" << endl;
  }

  void print() {
    cout << y << "-" << m << "-" << d << endl;
  }

};

int main() {
  Date date1;
  date1.print();

  Date date2(1991, 8, 18);
  date2.print();

  return 0;
}
